/* Test code for PR bin/40278 by Marc Olzheim <marcolz@stack.nl> */

#include <err.h>
#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <sysexits.h>
#include <time.h>

int
main(int argc, char * const * const argv)
{
	struct tm	tm, *tp;
	time_t		ts_init, ts_result;
	char		buf[128];

	if (1 != argc) {
		(void) fprintf(stderr, "Usage: %s\n", argv[0]);
		return EX_USAGE;
	}

	if (setenv("TZ", "CET", 1))
		err(EX_OSERR, "Could not setenv().");

	/* Not necessary, on stock FreeBSD, but still... */
	tzset();

	ts_init = 1014944400; /* Fri Mar 1 02:00:00 2002 CET */

	tp = localtime(&ts_init);
	tm = *tp;
	ts_result = mktime(&tm);
	if (!strftime(buf, 128, "%+", &tm))
		warn("strftime() returned 0");
	printf("\nInit: mktime: %lu %s\n", (unsigned long) ts_result, buf);

	tm.tm_mon += 1;
	tm.tm_mday = 0;
	ts_result = mktime(&tm);
	if (!strftime(buf, 128, "%+", &tm))
		warn("strftime() returned 0");

	printf("1: mktime: %lu %s\n", (unsigned long) ts_result, buf);

	tp = localtime(&ts_init);
	tm = *tp;
	ts_result = mktime(&tm);
	if (!strftime(buf, 128, "%+", &tm))
		warn("strftime() returned 0");
	printf("\nInit: mktime: %lu %s\n", (unsigned long) ts_result, buf);

	tm.tm_mon += 1;
	ts_result = mktime(&tm);
	if (!strftime(buf, 128, "%+", &tm))
		warn("strftime() returned 0");
	printf("2a: mktime: %lu %s\n", (unsigned long) ts_result, buf);

	tm.tm_mday = 0;
	ts_result = mktime(&tm);
	if (!strftime(buf, 128, "%+", &tm))
		warn("strftime() returned 0");
	printf("2b: mktime: %lu %s\n", (unsigned long) ts_result, buf);

	tp = localtime(&ts_init);
	tm = *tp;
	ts_result = mktime(&tm);
	if (!strftime(buf, 128, "%+", &tm))
		warn("strftime() returned 0");
	printf("\nInit: mktime: %lu %s\n", (unsigned long) ts_result, buf);

	tm.tm_mday = 0;
	ts_result = mktime(&tm);
	if (!strftime(buf, 128, "%+", &tm))
		warn("strftime() returned 0");
	printf("3a: mktime: %lu %s\n", (unsigned long) ts_result, buf);

	tm.tm_mon += 1;
	ts_result = mktime(&tm);
	if (!strftime(buf, 128, "%+", &tm))
		warn("strftime() returned 0");
	printf("3b: mktime: %lu %s\n", (unsigned long) ts_result, buf);

	return EX_OK;
}
